package com.test;


import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.test.ejb.TestBean;
import com.test.jpa.Person;


@WebServlet("/test")
public class TestServlet extends HttpServlet {

    private static final long serialVersionUID = 1L;

    @EJB(beanName = "Plain")
    private TestBean plain;

    @EJB(beanName = "CDI")
    private TestBean cdi;

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/html; charset=UTF-8");
        PrintWriter out = response.getWriter();
        String bean = request.getParameter("bean");
        if (bean == null) {
            out.printf("<a href=\"?bean=%1$s\">%1$s</a><br />%n", "plain");
            out.printf("<a href=\"?bean=%1$s\">%1$s</a><br />%n", "cdi");
        } else {
            try {
                TestBean invoked = bean.equalsIgnoreCase("plain") ? plain : cdi;
                List<Person> people = invoked.getPeople();
                if (people.size() == 0) {
                    out.println("Empty!");
                } else {
                    out.println("<ol>");
                    for (Person p : people) {
                        out.printf("<li> %s</li>", p);
                    }
                    out.println("</ol>");
                }
                out.println("<br /><br />");
                out.println("<a href=\".\">Back</a>");
            } catch (Exception exc) {
                throw new ServletException(exc);
            }
        }
    }
}
